using System;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Specialized;

namespace CsSoundStudy
{
  public class GetParamWav
  {

    riffChunk mainfile;
    fmtChunk format;
    factChunk fact;
    dataChunk data;

    public BinaryReader reader;

    public BinaryWriter writer; 

#region GetParamWavFile

    public riffChunk getMainData(string strFileName)
    {
      int nPrn = 1;      
      try
      {
        reader = new BinaryReader(new FileStream(strFileName, FileMode.Open, FileAccess.Read, 
                                           FileShare.Read));
      }
      catch (FileNotFoundException e)
      {
        Console.WriteLine(" WAV  ");
        Console.ReadKey();
        Environment.Exit(1);
        
      }
      
      mainfile = new riffChunk();
      mainfile.sGroupID = new string(reader.ReadChars(4));
      mainfile.dwFileLength = reader.ReadUInt32() + 8;
      mainfile.sRiffType = new string(reader.ReadChars(4));
      mainfile.FileName = strFileName;

      if(nPrn == 1)
      {
        Console.WriteLine("mainfile.sGroupID:\t {0}", mainfile.sGroupID);
        Console.WriteLine("mainfile.dwFileLength:\t {0}", mainfile.dwFileLength);
        Console.WriteLine("mainfile.sRiffType:\t {0}", mainfile.sRiffType);       
      }
      return mainfile;
    }

    public fmtChunk getFormatData()
    {
      int nPrn = 1;      
      format = new fmtChunk();
      format.sChunkID = new string(reader.ReadChars(4));
      format.dwChunkSize = reader.ReadUInt32();
      format.wFormatTag = reader.ReadUInt16();
      format.wChannels = reader.ReadUInt16();
      format.dwSamplesPerSec = reader.ReadUInt32();
      format.dwAvgBytesPerSec = reader.ReadUInt32();
      format.wBlockAlign = reader.ReadUInt16();
      format.dwBitsPerSample = reader.ReadUInt16(); //  reader.ReadUInt32() - 
      if (nPrn == 1)
      {
        Console.WriteLine("format.sChunkID:\t {0}", format.sChunkID.ToString());
        Console.WriteLine("format.dwChunkSize:\t {0}", format.dwChunkSize);
        Console.WriteLine("format.wFormatTag:\t {0}", format.wFormatTag);
        Console.WriteLine("format.wChannels:\t {0}", format.wChannels);
        Console.WriteLine("format.dwSamplesPerSec:\t {0}", format.dwSamplesPerSec);
        Console.WriteLine("format.dwAvgBytesPerSec:\t {0}", format.dwAvgBytesPerSec);
        Console.WriteLine("format.wBlockAlign:\t {0}", format.wBlockAlign);
        Console.WriteLine("format.dwBitsPerSample:\t {0}", format.dwBitsPerSample);
      }
      return format;
    }

    public factChunk getFactData()
    {
      factChunk fc = new factChunk();
      //string temp;
      //temp = new string(reader.ReadChars(4));
      //if(temp == "fact")
      return fc;
    }

    public dataChunk getDataParam()
    {
      int nPrn = 1;
      long nPosFile = reader.BaseStream.Position;
      //string strHeader = new string(reader.ReadChars(512));
      string strHeader = new string(reader.ReadChars(512));
      long nPosData = strHeader.IndexOf("data");
      if(nPosData == -1)
      {
        Console.WriteLine("  !");
        Console.ReadKey();
        Environment.Exit(1);
      } // if
      else
      {
        data = new dataChunk();
        reader.BaseStream.Seek(nPosFile + nPosData, SeekOrigin.Begin);
        data.sChunkID = new string(reader.ReadChars(4)); 
			  data.dwChunkSize = reader.ReadUInt32();
			  data.lFilePosition = (int) reader.BaseStream.Position;
        data.dwNumSamples = data.dwChunkSize / (format.dwBitsPerSample/8 * format.wChannels);
	      data.dwMinLength = (data.dwChunkSize / format.dwAvgBytesPerSec) / 60;
	      data.dSecLength = ((double)data.dwChunkSize / (double)format.dwAvgBytesPerSec) - 
                          (double)data.dwMinLength*60; 
        // data.dBegSamples  =  (int) reader.BaseStream.Position;  
        if (nPrn == 1)
        {
          Console.WriteLine("data.sChunkID:\t {0}", data.sChunkID);
          Console.WriteLine("data.dwChunkSize:\t {0}", data.dwChunkSize);
          Console.WriteLine("data.lFilePosition:\t {0}", data.lFilePosition);
          Console.WriteLine("data.dwNumSamples:\t {0}", data.dwNumSamples);
          Console.WriteLine("data.dwMinLength:\t {0}", data.dwMinLength);
          Console.WriteLine("data.dSecLength:\t {0}", data.dSecLength);
     
          for (int i = 0; i < 3; i++)
          {
            Console.WriteLine("{0}", reader.ReadInt16());
          }
        } //if
        //reader.BaseStream.Seek(data.lFilePosition, SeekOrigin.Begin);
        //reader.Close();
        return data;
      } // else
      reader.Close();
      return data;
    } // getDataParam()

#endregion GetParamWavFile

    public int WaveCreate(string strFileName)
    {
      int nPrn = 1;
      DateTime dt = DateTime.Now;
      string strFile = strFileName + dt.ToString("_yyyy_MM_dd_HH_mm") + ".wav";
      try
      {
        writer = new BinaryWriter(new FileStream(strFile, FileMode.Create, FileAccess.Write,
                                           FileShare.Write));
      }
      catch (FileNotFoundException e)
      {
        Console.WriteLine(" WAV  ");
        Console.ReadKey();
        Environment.Exit(1);
      } // WaveCreate(string strFileName)
      return 0;
    }

    public int WaveMake()
    {
      reader.BaseStream.Seek(0, SeekOrigin.Begin);
      writer.Write(reader.ReadChars(data.lFilePosition));
      long nWrPos = writer.BaseStream.Position;
      writer.BaseStream.Seek(data.lFilePosition, SeekOrigin.Begin);
      for(int i = 0; i < data.dwNumSamples; i++)
      {
        writer.Write(reader.ReadInt16() + 10);
      }
      reader.Close();
      writer.Close();
      return 0;
    }
  } //class GetParamWav
} // amespace CsSoundStudy
